import postcss, { Node, AcceptedPlugin } from 'postcss';
import { Options } from 'sass';
import { Config } from 'tailwindcss';
import { AtImportOptions } from 'postcss-import';

interface IProcessOptions {
    tailwindcssConfig?: string | Config | {
        config: string | Config;
    } | undefined;
    sassOptions?: Options<'sync'>;
    atImportOptions?: AtImportOptions;
}

type NodeMapKeys = 'base' | 'components' | 'utilities';
declare function createContext(opts?: IProcessOptions): {
    layersMap: Map<NodeMapKeys, Node[]>;
    append: (key: NodeMapKeys, nodes: Node | Node[]) => void;
    getNodes: (key: NodeMapKeys) => Node[];
    getPluginsSync(): AcceptedPlugin[];
    getPlugins(): Promise<AcceptedPlugin[]>;
    process(entry: string): Promise<postcss.Result<postcss.Root>>;
    processSync(entry: string): postcss.Result<postcss.Document | postcss.Root>;
    generate: () => string;
};
type IContext = ReturnType<typeof createContext>;

export { type IContext, type NodeMapKeys, createContext };
